con
  _clkmode = $62
  _clkfreq = $4E495053 ' SPIN

  kINTLITERAL = $40000000
  kFLOATLITERAL = $20000000

obj
  c : "clibos"

dat
  type long 0
  lineNum word 0
  column word 0
  buffer long 0, 0, 0, 0
  long 0, 0, 0, 0
  long 0, 0, 0, 0
  long 0, 0, 0, 0
  long 0, 0, 0, 0

pub main(argc, argv) | infile
  c.enter
  if argc <> 2
    c.printf0(string("usage: tokdump file\n"))
    c.exit(1)
  infile := c.fopen(long[argv][1], string("r"))
  ifnot infile
    c.printf1(string("Could not open %s\n"), long[argv][1])
    c.exit(1)
  repeat while c.fread(@type, 1, 8, infile) == 8
    if type == kINTLITERAL or type == kFLOATLITERAL
      c.fread(@buffer, 1, 4, infile)
      c.printf4(string("$%8.8x %3d %3d $%x\n"), type, lineNum, column, buffer)
    else
      c.fgets(@buffer, 100, infile)
      c.printf4(string("$%8.8x %3d %3d %s\n"), type, lineNum, column, @buffer)
  c.fclose(infile)
  c.exit(0)
